/*******************************************************************************
 *
 * File Name: stdafx.h
 * Author(s): Richard Bruce Baxter - Copyright (c) 2013 Baxter AI (baxterai.com)
 * Project: QFG5 Model
 * Project Version: 08-March-2013c
 * Description: global defs
 *
 *******************************************************************************/

#pragma once

//These parameters can be modified by the user:
//#define MDL_IMPORT_HAK_FILE_EXPECT_APPENDED_DOT_OUT_TO_FILE_NAME	//this enables batch input of batch converted HAK files (output with an appended .out)

//MDL DEVELOPMENT DEBUG VARIABLES ONLY (disable during public release):
//#define MDL_DEVEL_DEBUG_MISSING_TRIANGLES
//#define MDL_DEVEL_OLD_USING_EXISTING_UV_COORD_DATA
//#define MDL_DEVEL_TEMPORARILY_REMOVE_ADVANCED_UV_RECONCILATION
//#define MDL_DEVEL_DETERMINE_WHICH_UV_COORDINATES_ARE_BEING_REFERENCED_BY_FACES	//debug (l)
//#define MDL_DEVEL_EXPORT_UV_COORD_ARRAY_TO_HAK_AND_LDR_FILE	//DEBUG (g)
#ifdef MDL_DEVEL_EXPORT_UV_COORD_ARRAY_TO_HAK_AND_LDR_FILE
	//#define MDL_DEVEL_EXPORT_UV_COORD_ARRAY_TO_HAK_FILE_NORMALISE_WRT_FLAT_TEXTURE_512x256_DOESNT_WORK
#endif
//#define MDL_DEVEL_IMPORT_MESH_OF_EXACT_SAME_VALUES
//#ifdef MDL_DEVEL_IMPORT_MESH_OF_EXACT_SAME_VALUES
	//#define MDL_DEVEL_IMPORT_DESTROY_ALL_UV_NORMALS_AND_LIGHTING_DATA
	#ifdef MDL_DEVEL_IMPORT_DESTROY_ALL_UV_NORMALS_AND_LIGHTING_DATA
		//#define MDL_DEVEL_IMPORT_DESTROY_UV_COORD_ARRAY	//DEBUG (f)
	#endif
//#endif
//#define MDL_DEVEL_PRINT_3D_MESH_DATA
//#define MDL_DEVEL_OUTPUT_3D_MESH_LDR_POINT_MAP
//#define MDL_DEVEL_IMPORT_HAK_FILE

#define MDL_SUPPORT_IMPORT_MESH_OF_EXACT_SAME_VALUES

#define MDL_HEADER_NAME_ADDRESS 0x0C
#define MDL_HEADER_NUMBER_OF_SUBMESHES_ADDRESS 0x1C
#define MDL_HEADER_BITMAPPALETTE_ADDRESS 0x2D
#define MDL_HEADER_BITMAPHEADERADDRESSREFERENCE_ADDRESS 0x428
#define MDL_HEADER_3DDATA_ADDRESS 0x42c

#define BITMAP_PALETTE_LENGTH 1019	//modified 22 Feb 2013 - to account for MDL palette size specification (0x427 - 0x2D + 1 = 1019)
#define SUBMESH_NAME_LENGTH 10
#define SUBMESH_DATAPOINTS_PER_VERTEX (3)
#define SUBMESH_DATAPOINTS_PER_UV_COORDS (2)
#define SUBMESH_DATAPOINTS_PER_FACE (10)
	#define SUBMESH_DATAPOINTS_VERTICES_PER_FACE (3)
	#define SUBMESH_DATAPOINTS_UVCOORDS_PER_FACE (3)
	#define SUBMESH_DATAPOINTS_PER_NORMAL (3)
	#define SUBMESH_DATAPOINTS_NORMALS_PER_FACE (1)
	#define SUBMESH_DATAPOINTS_FACE_INDEX_OF_FIRST_VERTEX (0)
	#define SUBMESH_DATAPOINTS_FACE_INDEX_OF_FIRST_UVCOORD (3)
	#define SUBMESH_DATAPOINTS_FACE_INDEX_OF_UNKNOWN (6)
	#define SUBMESH_DATAPOINTS_FACE_INDEX_OF_NORMAL (7)
#define SUBMESH_DATAPOINTS_PER_LIGHTING_ENTRY (4)
#define SUBMESH_NUMBER_OF_LIGHTING_ENTRIES_PER_VERTEX (SUBMESH_DATAPOINTS_PER_LIGHTING_ENTRY)
#define SUBMESH_HEADER_NAME_ADDRESS (0x00)
#define SUBMESH_HEADER_NUMBER_OF_VERTICES_ADDRESS (0x60)
#define SUBMESH_HEADER_NUMBER_OF_UVCOORDS_ADDRESS (0x64)
#define SUBMESH_HEADER_NUMBER_OF_FACES_ADDRESS (0x68)
#define SUBMESH_HEADER_VERTICES_LIST_ADDRESS (0x7C)

#define SUBMESH_DATAPOINT_MAX_LENGTH (20)		//max length of any float or int
// TODO: reference additional headers your program requires here

#define CHAR_NEWLINE '\n'
#define CHAR_SPACE ' '
#define HAK_HEADER_COMMENT_CHAR '%'
#define HAK_HEADER_VERTICES_CHAR 'v'
#define HAK_HEADER_TRIANGES_CHAR 'f'
#define HAK_HEADER_VERTICES_TYPE_CHAR '3'
#define HAK_HEADER_TRIANGES_TYPE_CHAR '2'
#define HAK_BAD_VERTEX "-1.#IND"

#define BYTES_PER_INT (4)

#define SOME_LARGE_DISTANCE (10000000.0F)
#define DOUBLE_MIN_PRECISION (0.00001F)
#define DOUBLE_RELAXED_PRECISION (0.01F)	//TO DO: need to test changing this to 0.001F (and merging with DOUBLE_MODERATELY_RELAXED_PRECISION)
#define DOUBLE_MODERATELY_RELAXED_PRECISION (0.0001F)

#define MDL_BITMAP_HEADER_TYPE_MULTIPLIER (4)
#define SUBBITMAP_HEADER_LENGTH (24)
#define SUBBITMAP_HEADER_WIDTH_FLOAT_ADDRESS (0)
#define SUBBITMAP_HEADER_HEIGHT_FLOAT_ADDRESS (4)
#define SUBBITMAP_HEADER_WIDTH_POWER_OF_TWO_ADDRESS (8)
#define SUBBITMAP_HEADER_HEIGHT_POWER_OF_TWO_ADDRESS (12)
#define SUBBITMAP_HEADER_WIDTH_MINUS_ONE_ADDRESS (16)
#define SUBBITMAP_HEADER_HEIGHT_MINUS_ONE_ADDRESS (20)

#define BMP_EXTENSION ".BMP"
#define MDL_EXTENSION ".MDL"
#define HAK_EXTENSION ".hak"
#define LDR_EXTENSION ".ldr"
